Index: /anuga_core/documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 5554)
+++ /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 5555)
@@ -2075,5 +2075,5 @@
 specified interpolation points from a NetCDF file (\code{filename})
 and returns
-a callable object. \code{filename} could be a \code{sww} file.
+a callable object. \code{filename} could be a \code{sww} or \code{sts} file.
 Returns interpolated values based on the input
 file using the underlying \code{interpolation\_function}.
@@ -2087,4 +2087,6 @@
 for points at which values are sought.
 
+\code{boundary_polygon} is a list of coordinates specifying the vertices of the boundary. This must be the same polygon as used when calling \code{create_mesh_from_regions}. This argument can only be used when reading boundary data from the STS format.
+
 The model time stored within the file function can be accessed using
 the method \code{f.get\_time()}
@@ -2093,7 +2095,9 @@
 The underlying algorithm used is as follows:\\
 Given a time series (i.e.\ a series of values associated with
-different times), whose values are either just numbers or a set of
+different times), whose values are either just numbers, a set of
  numbers defined at the vertices of a triangular mesh (such as those
- stored in SWW files), \code{Interpolation\_function} is used to
+ stored in SWW files) or a set of
+ numbers defined at a number of points on the boundary (such as those
+ stored in STS files), \code{Interpolation\_function} is used to
  create a callable object that interpolates a value for an arbitrary
  time \code{t} within the model limits and possibly a point \code{(x,
@@ -2107,6 +2111,6 @@
  \code{quantities}. The optional arguments \code{vertex\_coordinates}
  and \code{triangles} represent the spatial mesh associated with the
- quantity arrays. If omitted the function created by
- \code{Interpolation\_function} will be a function of \code{t} only.
+ quantity arrays. If omitted the function must be created using an STS file
+ or a TMS file.
 
  Since, in practice, values need to be computed at specified points,
@@ -2245,6 +2249,6 @@
 Module: \module{abstract\_2d\_finite\_volumes.generic\_boundary\_conditions}
 
-This method may be used if the user wishes to apply a SWW file or
-a time series file to a boundary segment or segments.
+This method may be used if the user wishes to apply a SWW file, STS file or
+a time series file (TMS) to a boundary segment or segments.
 The boundary values are obtained from a file and interpolated to the
 appropriate segments for each conserved quantity.
@@ -2844,6 +2848,8 @@
 \hline\hline
 
-\code{.sww} & NetCDF format for storing model output
+\code{.sww} & NetCDF format for storing model output with mesh information
 \code{f(t,x,y)}\\
+
+\code{.sts} & NetCDF format for storing model ouput \code{f(t,x,y)} without any mesh information\\
 
 \code{.tms} & NetCDF format for storing time series \code{f(t)}\\
@@ -2920,8 +2926,8 @@
 \bigskip
 
-\subsection{SWW and TMS Formats}
+\subsection{SWW, STS and TMS Formats}
 \label{sec:sww format}
 
-The SWW and TMS formats are both NetCDF formats, and are of key
+The SWW, STS and TMS formats are all NetCDF formats, and are of key
 importance for \anuga.
 
@@ -2960,4 +2966,16 @@
 for functions such as \function{file\_boundary} and
 \function{file\_function}, described in Chapter \ref{ch:interface}.
+
+An STS file is used for storing a set of points and and associated set of times.
+It contains, in addition to dimension information, the following
+variables:
+\begin{itemize}
+    \item \code{x} and \code{y}: coordinates of the points, represented as Numeric arrays
+    \item \code{elevation}, a Numeric array storing bed-elevations
+    % Refer here to the example to be provided in describing the simple example
+    \item \code{time}, a Numeric array containing times for model
+    evaluation
+\end{itemize}
+The only difference between the STS format and the SWW format is the former does not contain a list specifying the points at the vertices of each of the triangles (\code{volumes}). Consequenlty information (arrays) stored within an STS file such as \code{elevation} can be accessed in exactly the same way as it would be extraced from an SWW file.
 
 A TMS file is used to store time series data that is independent of
@@ -3091,4 +3109,13 @@
   Takes DEM data (a NetCDF file representation of data from a regular Digital
   Elevation Model) and converts it to PTS format.
+  \end{funcdesc}
+
+  \begin{funcdesc}{urs2sts}{basename_in, basename_out=None, 
+            weights=None, verbose=False, 
+            origin=None,mean_stage=0.0, 
+            zscale=1.0, ordering_filename=None}
+  Module: \module{shallow\_water.data\_manager}
+
+  Takes urs data in (timeseries data in mux2 format) and converts it to STS format.
   \end{funcdesc}
 
@@ -4345,5 +4372,5 @@
 G2 = Geospatial_data(file_name = 25m_dem_name + '.pts')
 G = G1 + G2
-G.export_points_file(combined_dem_name + .pts)
+G.export_points_file(combined_dem_name + ï¿œ.ptsï¿œ)
 \end{verbatim}}
 this is the basic way of combining data sets, however, the user will need to