Index: /anuga_core/documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 5565)
+++ /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 5566)
@@ -94,5 +94,5 @@
 
 \noindent \anuga\index{\anuga} is a hydrodynamic modelling tool that
-allows users to model realistic flow problems in complex geometries.
+allows users to model realistic flow problems in complex 2D geometries.
 Examples include dam breaks or the effects of natural hazards such
 as riverine flooding, storm surges and tsunami.
@@ -101,7 +101,5 @@
 cells, the topography and bathymetry, frictional resistance, initial
 values for water level (called \emph{stage}\index{stage} within \anuga),
-boundary
-conditions and forces such as windstress or pressure gradients if
-applicable.
+boundary conditions and forces such as rainfall, stream flows, windstress or pressure gradients if applicable.
 
 \anuga tracks the evolution of water depth and horizontal momentum
@@ -223,10 +221,10 @@
   As such it cannot resolve vertical convection and consequently not breaking
   waves or 3D turbulence (e.g.\ vorticity).
-  \item The surface is assumed to be open, e.g. \anuga cannot model
-  flow under ceilings or in pipes
+  %\item The surface is assumed to be open, e.g. \anuga cannot model
+  %flow under ceilings or in pipes
   \item All spatial coordinates are assumed to be UTM (meters). As such,
   ANUGA is unsuitable for modelling flows in areas larger than one UTM zone
   (6 degrees wide).
-  \item Fluid is assumed to be inviscid
+  \item Fluid is assumed to be inviscid - i.e.\ no kinematic viscosity included. 
   \item The finite volume is a very robust and flexible numerical technique,
   but it is not the fastest method around. If the geometry is sufficiently
@@ -236,6 +234,6 @@
   \item Frictional resistance is implemented using Manning's formula, but
   \anuga has not yet been fully validated in regard to bottom roughness
-  \item ANUGA contains no tsunami-genic functionality relating to
-  earthquakes.
+  %\item ANUGA contains no tsunami-genic functionality relating to
+  %earthquakes.
 \end{itemize}
 
@@ -247,5 +245,5 @@
 This section is designed to assist the reader to get started with
 \anuga by working through some examples. Two examples are discussed;
-the first is a simple example to illustrate many of the ideas, and
+the first is a simple example to illustrate many of the concepts, and
 the second is a more realistic example.
 
@@ -2329,4 +2327,5 @@
   \end{itemize}
   Note specifying both center, radius and polygon will cause an exception to be thrown.
+  Moreover, if the specified polygon or circle does not lie fully within the mesh boundary an Exception will be thrown.
 
   \bigskip  
@@ -2353,5 +2352,5 @@
   Module: \module{shallow\_water.shallow\_water\_domain}
 
-  This is a general class for infiltration and abstraction of water according to a given rate of change.
+  This is a general class for inflow and abstraction of water according to a given rate of change.
   This class will always modify the \code{stage} quantity.
   
@@ -2446,5 +2445,5 @@
   \end{itemize}
 
-  The user can specify different culvert routines. Hower ANUGA currently specifies one, namely the \code{boyd\_generalised\_culvert\_model} as used in the example below.
+  The user can specify different culvert routines. Hower ANUGA currently provides only one, namely the \code{boyd\_generalised\_culvert\_model} as used in the example below.
       
   \bigskip        
@@ -2772,5 +2771,5 @@
   Module: \module{shallow\_water.data\_manager}
 
-  Obtain flow $[m^2]$ perpendicular to specified cross section.
+  Obtain flow $[m^3/s]$ perpendicular to specified cross section.
 
   Inputs:
@@ -3065,5 +3064,5 @@
 \subsection{DEM Format}
 
-A DEM file is a NetCDF representation of regular DEM data.
+A DEM file in \ANUGA is a NetCDF representation of regular DEM data.
 
 
@@ -3179,8 +3178,10 @@
 \]
 in which $\eta$ is the Manning resistance coefficient.
+The model does not currently include consideration of kinematic viscosity.
 
 As demonstrated in our papers, \cite{ZR1999,nielsen2005} these
-equations provide an excellent model of flows associated with
-inundation such as dam breaks and tsunamis.
+equations and their implementation in \ANUGA provide a reliable 
+model of general flows associated with inundation such as dam breaks 
+and tsunamis.
 
 \section{Finite Volume Method}
@@ -3863,4 +3864,8 @@
 If no value is specified, the default attribute is taken to be the
 first one.
+
+Note that the Geospatial\_data object currently reads entire datasets 
+into memory i.e.\ no memomry blocking takes place.  
+For this we refer to the set\_quantity method which will read .pts and .csv files into \ANUGA using memory blocking allowing large files to be used.
 \end{classdesc}
 
@@ -4164,5 +4169,6 @@
 \label{mod:neighbourmesh}
 
-\section{\module{abstract\_2d\_finite\_volumes.domain} --- Generic module for 2D triangular domains for finite-volume computations of conservation laws}
+\section{\module{abstract\_2d\_finite\_volumes.domain}}
+Generic module for 2D triangular domains for finite-volume computations of conservation laws
 \declaremodule{}{domain}
 \label{mod:domain}
@@ -4194,9 +4200,9 @@
 
 
-\section{\module{shallow\_water} --- 2D triangular domains for finite-volume
-computations of the shallow water wave equation. This module contains a specialisation
-of class Domain from module domain.py consisting of methods specific to the Shallow Water
+\section{\module{shallow\_water}}
+2D triangular domains for finite-volume
+computations of the shallow water wave equation. 
+This module contains a specialisation of class Domain from module domain.py consisting of methods specific to the Shallow Water
 Wave Equation
-}
 \declaremodule[shallowwater]{}{shallow\_water}
 \label{mod:shallowwater}
@@ -4287,5 +4293,5 @@
 quantities \code{stage}, \code{xmomentum} and \code{ymomentum} at a given point in time
 and space as a triplet. To access e.g.\ \code{stage} one must specify element 0 of the
-triplet returned by file\_function.
+triplet returned by file\_function, to access \code{xmomentum} one must specify element 1 of the triplet etc.
 
 \subsubsection{Which diagnostics are available to troubleshoot a simulation?}
@@ -4300,9 +4306,15 @@
 data is often sparse, or non-existent.
 
+Note that onshore DEMS can be much finer as the underlying datasets from which they 
+are created often contain several datapoints per m$^2$. 
+It may be necessary to thin out the data so that it can be imported 
+without exceeding available memory. One tool available on the net is called 'decimate'. %FIXME: (Need reference?).  
+
+
 \subsubsection{What sort of mesh resolution should I use?}
 The mesh resolution should be commensurate with your DEM - it does not make sense to put in place a mesh which is finer than your DEM. As an example,
 if your DEM is on a 25m grid, then the cell resolution should be of the order of 315$m^2$ (this represents half the area of the square grid). Ideally,
 you need a fine mesh over regions where the DEM changes rapidly, and other areas of significant interest, such as the coast.
-If meshes are too coarse, discretisation errors in both stage and momentum may lead to unphysical results. All studies should include sensitivity and convergence studies based on different resolutions.
+If meshes are too coarse, discretisation errors in both stage and momentum may lead to unrealistic results. All studies should include sensitivity and convergence studies based on different resolutions.
 
 
Index: /anuga_core/documentation/user_manual/copyright.tex
===================================================================
--- /anuga_core/documentation/user_manual/copyright.tex	(revision 5565)
+++ /anuga_core/documentation/user_manual/copyright.tex	(revision 5566)
@@ -80,5 +80,5 @@
 \begin{itemize}
 \item \anuga was developed and is maintained by Stephen Roberts,
-  Ole Nielsen, Duncan Gray, Jane Sexton and Nick Bartzis.
+  Ole Nielsen, Duncan Gray and Jane Sexton.
 \index{ANUGA!credits|textit}  
 \end{itemize}
@@ -95,5 +95,5 @@
 \textbf{Acknowledgments}:
 \begin{itemize}
-\item Christopher Zoppou, Linda Stals, Matt Hardy, Jack Kelly, John Jakeman, Trevor Dhu, who contributed to this project at various times.
+\item John Jakeman, Rudy van Drie, Ted Rigby, Joaquim Luis, Nils Goseberg, William Power, Petar Milevski, Trevor Dhu, Linda Stals, Matt Hardy, Jack Kelly and Christopher Zoppou who contributed to this project at various times.
 \item A stand alone visualiser (anuga\_viewer) based on Open-scene-graph was developed by Darran Edmundson.
 \item The mesh generator engine was written by Jonathan Richard Shewchuk and made freely available under the following license. 
Index: /anuga_core/source/anuga/fit_interpolate/interpolate.py
===================================================================
--- /anuga_core/source/anuga/fit_interpolate/interpolate.py	(revision 5565)
+++ /anuga_core/source/anuga/fit_interpolate/interpolate.py	(revision 5566)
@@ -626,5 +626,5 @@
             quantity_names = ['Attribute']
 
-            #Make it a dictionary
+            # Make it a dictionary
             quantities = {quantity_names[0]: quantities}
 