Index: /anuga_core/source/anuga/shallow_water/data_manager.py
===================================================================
--- /anuga_core/source/anuga/shallow_water/data_manager.py	(revision 5626)
+++ /anuga_core/source/anuga/shallow_water/data_manager.py	(revision 5627)
@@ -1670,4 +1670,5 @@
                 reduction = None,
                 cellsize = 10,
+                number_of_decimal_places = None,
                 NODATA_value = -9999,
                 easting_min = None,
@@ -1727,4 +1728,5 @@
                                reduction,
                                cellsize,
+                               number_of_decimal_places,
                                NODATA_value,
                                easting_min,
@@ -1824,4 +1826,5 @@
             reduction = None,
             cellsize = 10,
+            number_of_decimal_places = None,
             NODATA_value = -9999,
             easting_min = None,
@@ -1904,4 +1907,7 @@
     if quantity_formula.has_key(quantity):
         quantity = quantity_formula[quantity]
+
+    if number_of_decimal_places is None:
+        number_of_decimal_places = 9
         
     swwfile = basename_in + '.sww'
@@ -2181,7 +2187,7 @@
 
             slice = grid_values[base_index:base_index+ncols]
-            s = array2string(slice, max_line_width=sys.maxint)
+            #s = array2string(slice, max_line_width=sys.maxint)
+            s = array2string(slice, max_line_width=sys.maxint, precision=number_of_decimal_places)
             ascid.write(s[1:-1] + '\n')
-
 
             #print
@@ -2213,4 +2219,5 @@
             reduction = reduction,
             cellsize = cellsize,
+            number_of_decimal_places = number_of_decimal_places,
             verbose = verbose,
             origin = origin,
@@ -2233,4 +2240,5 @@
             reduction = reduction,
             cellsize = cellsize,
+            number_of_decimal_places = number_of_decimal_places,
             verbose = verbose,
             origin = origin,
Index: /anuga_core/source/anuga/shallow_water/test_data_manager.py
===================================================================
--- /anuga_core/source/anuga/shallow_water/test_data_manager.py	(revision 5626)
+++ /anuga_core/source/anuga/shallow_water/test_data_manager.py	(revision 5627)
@@ -1281,4 +1281,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 verbose = self.verbose,
                 format = 'asc')
@@ -1369,4 +1370,5 @@
                 quantity = 'depth',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 verbose = self.verbose,
                 format = 'asc')
@@ -2003,4 +2005,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 verbose = self.verbose,
                 format = 'asc')
@@ -2189,4 +2192,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 easting_min = 308530,
                 easting_max = 308570,
@@ -2336,4 +2340,5 @@
                 quantity = 'stage',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 reduction = min,
                 format = 'asc',
@@ -2449,4 +2454,5 @@
                 quantity = 'stage - elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 reduction = min,
                 format = 'asc',
@@ -2600,4 +2606,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 verbose = self.verbose,
                 format = 'asc')
@@ -2707,4 +2714,5 @@
                 quantity = 'elevation',
                 cellsize = cellsize,
+                number_of_decimal_places = 9,
                 NODATA_value = NODATA_value,
                 verbose = self.verbose,
@@ -4148,4 +4156,5 @@
                 quantity = 'depth',
                 cellsize = 200000,
+                number_of_decimal_places = 9,
                 verbose = True)
 